import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Axe extends Weapons
{   
    private int timer;
    
    private GreenfootImage axeRight, axeDown, axeUp, axeLeft;
    
    //speed of projectile
    private int axeSpeed= 5;
    
    private static final int damage = 10;
    
    public Axe()
    {
        axeRight = new GreenfootImage("AxeRight.png");
        axeDown = new GreenfootImage("AxeDown.png");
        axeLeft = new GreenfootImage("AxeLeft.png");
        axeUp = new GreenfootImage("AxeUp.png");
        
        setImage(axeRight);
        
        Greenfoot.playSound("axe.wav");
    }
    
    //will damage enemy if it hits them.
    public void act() 
    {
        checkHit();
        move(axeSpeed);
        animateAxe();
    }
        
    //try to detect a hit to the enemy.
    private void checkHit()
    {
        Hero hero = (Hero) getOneIntersectingObject(Hero.class);
        if (hero != null)
        {
            getWorld().removeObject(this);
            hero.hit(damage);
        }
        else if(atWorldEdge())
        {
            getWorld().removeObject (this);
        }
    }
    
    public void animateAxe()
    {
        timer++;
        if (timer > 10 && timer < 20)
        {
            setImage(axeDown);
        }
        if (timer > 19 && timer < 30)
        {
            setImage(axeLeft);
        }
        if (timer > 29 && timer < 40)
        {
            setImage(axeUp);
        }
        if (timer > 39)
        {
            setImage(axeRight);
            timer = 0;
        }
    }
}
