import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.Scanner;
import java.util.List;

/**
 * Creates the world that CoolDude will play in
 * 
 * Created by Mike Locke-Paddon, reverse engineered from code by 
 * Chris Sudbrink and Cameron Petras
 */

public class CoolDudeWorld extends World
{
    //Declaring a variable to reference the instructions object
    private Instructions inst;
    //Declaring a variable to store the life value from Hero
    private Display lifeDisplay;
    //Declaring a variable for a max life display
    private Display maxLifeDisplay;
    //To place a damage display
    private Display damageDisplay;
    //To place a distance display
    private Display distanceDisplay;
    //To place a speed display
    private Display speedDisplay;
    //To place a new StatusMenu on the left side of the screen
    private StatusMenu sMenu;

    /**
     * Constructor for objects of class CoolDudeWorld.
     */
    public CoolDudeWorld()
    {         
        super(900, 600, 1);
        
        sMenu = new StatusMenu();
        addObject(sMenu, 50, getHeight() / 2);
        
        lifeDisplay = new Display("Life: ");
        addObject(lifeDisplay, 54, 30);
        
        maxLifeDisplay = new Display("MaxLife: ");
        addObject(maxLifeDisplay, 69, 50);       
        
        damageDisplay = new Display("Damage: ");
        addObject(damageDisplay, 64, 70);
        
        distanceDisplay = new Display("Distance: ");
        addObject(distanceDisplay, 74, 90);
        
        speedDisplay = new Display("Speed: ");
        addObject(speedDisplay, 58, 110);
        
        //adds the characters
        addObject(new Hero(), getWidth() / 2, getHeight() / 2);
        updateLifeDisplay(50);
        updateMaxLifeDisplay(50);
        updateDamageDisplay(10);
        updateDistanceDisplay(5);
        updateSpeedDisplay(2);

        inst = new Instructions();
        addObject(inst, getWidth() / 2, getHeight() / 2);      
    }
    
    public void updateLifeDisplay(int amount)
    {
        lifeDisplay.displayValue(amount);
        lifeDisplay.updateImage();
    }
    
    public void updateMaxLifeDisplay(int amount)
    {
        maxLifeDisplay.displayValue(amount);
        maxLifeDisplay.updateImage();
    }
    
    public void updateDamageDisplay(int amount)
    {
        damageDisplay.displayValue(amount);
        damageDisplay.updateImage();
    }
    
    public void updateDistanceDisplay(int amount)
    {
        distanceDisplay.displayValue(amount);
        distanceDisplay.updateImage();
    }
    
    public void updateSpeedDisplay(int amount)
    {
        speedDisplay.displayValue(amount);
        speedDisplay.updateImage();
    }
}
