import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class DarkKnight here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class EvilKnight extends Enemy
{
    private int life;

    private int fireTimer = 20;

    private int spearDirection;

    private GreenfootImage imageUp1, imageUp2, imageUp3, imageUp4, imageLeft1, imageLeft2, imageLeft3, imageLeft4,
    imageRight1, imageRight2, imageRight3, imageRight4, imageDown1, imageDown2, imageDown3, imageDown4;

    private int timeCount;
    private int MOVEDISTANCE = 19;
    private int directionFacing = 1;
    private int stepCount;
    private final int SPEED = 4;

    public EvilKnight()
    {
        imageDown1 = new GreenfootImage("EKDown1.png");
        imageDown2 = new GreenfootImage("EKDown2.png");
        imageDown3 = new GreenfootImage("EKDown3.png");
        imageDown4 = new GreenfootImage("EKDown4.png");
        imageLeft1 = new GreenfootImage("EKLeft1.png");
        imageLeft2 = new GreenfootImage("EKLeft2.png");
        imageLeft3 = new GreenfootImage("EKLeft3.png");
        imageLeft4 = new GreenfootImage("EKLeft4.png");
        imageRight1 = new GreenfootImage("EKRight1.png");
        imageRight2 = new GreenfootImage("EKRight2.png");
        imageRight3 = new GreenfootImage("EKRight3.png");
        imageRight4 = new GreenfootImage("EKRight4.png");
        imageUp1 = new GreenfootImage("EKUp1.png");
        imageUp2 = new GreenfootImage("EKUp2.png");
        imageUp3 = new GreenfootImage("EKUp3.png");
        imageUp4 = new GreenfootImage("EKUp4.png");

        setImage(imageDown1);

        life = 100;
    }

    /**
     * Act - do whatever the Enemy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        edgeCorrection();
        EKMove();
        animate();
        reduceFireTimer();
        throwSpear();
    }    

    //These are for animating the EvilKnight's movements
    private void changeImage1()
    {
        if (getImage() == imageRight1) setImage (imageRight2);
        if (getImage() == imageDown1) setImage (imageDown2);
        if (getImage() == imageLeft1) setImage (imageLeft2);
        if (getImage() == imageUp1) setImage (imageUp2);
    }

    private void changeImage2()
    {
        if (getImage() == imageRight2) setImage (imageRight3);
        if (getImage() == imageDown2) setImage (imageDown3);
        if (getImage() == imageLeft2) setImage (imageLeft3);
        if (getImage() == imageUp2) setImage (imageUp3);
    }

    private void changeImage3()
    {
        if (getImage() == imageRight3) setImage (imageRight4);
        if (getImage() == imageDown3) setImage (imageDown4);
        if (getImage() == imageLeft3) setImage (imageLeft4);
        if (getImage() == imageUp3) setImage (imageUp4);
    }

    private void changeImage4()
    {
        if (getImage() == imageRight4) setImage (imageRight1);
        if (getImage() == imageDown4) setImage (imageDown1);
        if (getImage() == imageLeft4) setImage (imageLeft1);
        if (getImage() == imageUp4) setImage (imageUp1);
    }

    //The actual animation method
    private void animate()
    {
        timeCount++;
        if (timeCount > 5 && timeCount < 11)
        {
            changeImage1();
        }
        if (timeCount > 10 && timeCount < 16 )
        {
            changeImage2();
        }
        if (timeCount > 15 && timeCount < 21)
        {
            changeImage3();
        }
        if (timeCount > 20)
        {
            changeImage4();
            timeCount = 0;
        }
    }

    //The method that controls the actual movement of the skeleton
    private void EKMove()
    {
        if (stepCount < MOVEDISTANCE)
        {

            if (directionFacing == 0)
            {
                setLocation (getX() + SPEED, getY());
                stepCount++;
                spearDirection = 0;
            }
            if (directionFacing == 2)
            {
                setLocation (getX() - SPEED, getY());
                stepCount++;
                spearDirection = 180;
            }
            if (directionFacing == 3)
            {
                setLocation (getX(), getY() - SPEED);
                stepCount++;
                spearDirection = 270;
            }
            if (directionFacing == 1)
            {
                setLocation (getX(), getY() + SPEED);
                stepCount++;
                spearDirection = 90;
            }
        }
        if (stepCount > MOVEDISTANCE - 1)
        {
            stepCount = 0;
            setDirection();
        }
    }

    private int chooseDirection()
    {
        int direction = Greenfoot.getRandomNumber(4);
        return (direction);
    }

    private void setDirection()
    {
        if (Greenfoot.getRandomNumber(99) < 25)
        {
            chooseDirection();
            if (chooseDirection() == 0)
            {
                setImage(imageRight1);
                directionFacing = 0;
            }
            if (chooseDirection() == 1)
            {
                setImage(imageDown1);
                directionFacing = 1;
            }
            if (chooseDirection() == 2)
            {
                setImage(imageLeft1);
                directionFacing = 2;
            }
            if (chooseDirection() == 3)
            {
                setImage(imageUp1);
                directionFacing = 3;
            }
        }
    }

    public int getLife()
    {
        return life;
    }

    public void die()
    {
        if (life < 1)
        {
            int rand = Greenfoot.getRandomNumber(100);
            if (rand < 100 && rand > 60)
            {
                dropApple();
            }
            else if(rand < 60 && rand > 30)
            {
                dropBananas();
            }
            else if (rand < 20)
            {
                dropRedPowerBall();
            }
            DeathAnimation death = new DeathAnimation();
            getWorld().addObject(death, getX(), getY());
            getWorld().removeObject(this);
        }
    }

    public void edgeCorrection()
    {
        if (getX() < 125)
        {
            directionFacing = 0;
            setImage(imageRight1);
        }
        else if (getX() > getWorld().getWidth() - 25)
        {
            directionFacing = 2;
            setImage(imageLeft1);
        }
        else if (getY() < 25)
        {
            directionFacing = 1;
            setImage(imageDown1);
        }
        else if (getY() > getWorld().getHeight() - 25)
        {
            directionFacing = 3;
            setImage(imageUp1);
        }

        if(getOneIntersectingObject(Tile.class) != null)
        {
            if(directionFacing == 0)
            {
                directionFacing = 2;
                setImage(imageLeft1);
            }
            else if(directionFacing == 1)
            {
                directionFacing = 3;
                setImage(imageUp1);
            }
            else if(directionFacing == 2)
            {
                directionFacing = 0;
                setImage(imageRight1);
            }
            else if(directionFacing == 3)
            {
                directionFacing = 1;
                setImage(imageDown1);
            }

        }
    }

    public void hit(int damage)
    {
        Greenfoot.playSound("enemyhit.wav");
        life = life - damage;
        if(life <= 0)
            die();
    }

    public void throwSpear()
    {
        if (fireTimer == 0 && (Greenfoot.getRandomNumber(100) < 30))
        {
            Spear spear = new Spear();
            getWorld().addObject(spear, getX(), getY());
            spear.setRotation(spearDirection);
            fireTimer = 50;
        }
    }

    public void reduceFireTimer()
    {
        if (fireTimer > 0)
        {
            fireTimer--;
        }
    }
}
