import greenfoot.*;  
import java.io.*;
import java.util.Scanner;
import java.util.List;

/**
 * Mike Locke-Paddon, with assistance from Bruce Tatem and Jared Jensen.
 * 11/1/12
 */
public class Hero extends Mover
{       
    private int timer;

    /**
     * All the variables that control Hero's stats.
     */

    //Hero's current life
    public static int life;
    //Hero's current max life
    public static int maxLife;
    //Hero's total possible max life
    public static final int TOTALMAXLIFE = 200;
    //sword's damage output
    public static int swordDamage;
    //sword's max possible damage
    public final int MAXSWORDDAMAGE = 35;
    //sword throwing distance
    public static int swordLife;
    //max of sword throwing distance
    public final int SWORDLIFEMAX = 30;
    //speed of Hero
    private static int speed = 2;
    //Max possible speed of hero
    private static final int MAXSPEED = 7;
    //Refire rate
    private static final int REFIRERATE = 30;
    //refire rate
    private int fireTimer = 0;

    private GreenfootImage imageUp1, imageUp2, imageUp3, imageUp4, imageDown1, imageDown2,
    imageDown3, imageDown4, imageRight1, imageRight2, imageRight3, imageRight4, imageLeft1,
    imageLeft2, imageLeft3, imageLeft4;

    //variables for tiles, map design.
    private static final int TILE_WIDTH = 50;
    private static final int TILE_HEIGHT = 50;
    private int leftX = TILE_WIDTH / 2;
    private int topY = TILE_HEIGHT / 2;
    private static final int MAP_HEIGHT = 12;
    private static final int MAP_WIDTH = 18;

    //a variable to store which map the hero is playing in
    private int level;

    //Some CoolDude Music specifically for CoolDude
    private GreenfootSound music;

    //Booleans to determine if items have been found by hero
    private boolean heroShades;
    private boolean keyItems;
    private boolean heroMystery;
    //these check to see if the world has added the items
    private boolean wShades;
    private boolean wMystery;

    //this makes sure that only one boss can enter the world
    private boolean wBoss;

    //the constructor for the first hero
    public Hero()
    {
        imageDown1 = new GreenfootImage("center1.png");
        imageDown2 = new GreenfootImage("center2.png");
        imageDown3 = new GreenfootImage("center3.png");
        imageDown4 = new GreenfootImage("center4.png");
        imageLeft1 = new GreenfootImage("left1.png");
        imageLeft2 = new GreenfootImage("left2.png"); 
        imageLeft3 = new GreenfootImage("left3.png");
        imageLeft4 = new GreenfootImage("left4.png");
        imageRight1 = new GreenfootImage("right1.png");
        imageRight2 = new GreenfootImage("right2.png"); 
        imageRight3 = new GreenfootImage("right3.png");
        imageRight4 = new GreenfootImage("right4.png");
        imageUp1 = new GreenfootImage("up1.png");
        imageUp2 = new GreenfootImage("up2.png"); 
        imageUp3 = new GreenfootImage("up3.png");
        imageUp4 = new GreenfootImage("up4.png");

        swordLife = 5;
        swordDamage = 10;

        setImage(imageDown1);

        maxLife = 50;
        life = 50;
        level = 5;
        music = new GreenfootSound("CoolDude Music.mid");

        heroShades = false;
        keyItems = false;
        heroMystery = false;
        wShades = false;
        wMystery = false;
        wBoss = false;
    }

    public static int getSwordLife()
    {
        return swordLife;
    }

    public static int getSwordDamage()
    {
        return swordDamage;
    }

    public void act() 
    {
        checkKeyPress();
        reduceFireTimer();
        lookForItem();
        determineMaps();
    }

    public void playMusic()
    {
        music.playLoop();
    }

    public void stopMusic()
    {
        music.stop();
    }

    public void determineMaps()
    {
        World w = getWorld();

        //creates a list of tiles to remove when the level variable changes
        List<Tile> tiles = w.getObjects(Tile.class);

        //creates a list of enemies to remove when the level variable changes
        List<Enemy> enemies = w.getObjects(Enemy.class);

        //creates a list of items to remove when the level variable changes
        List<Item> items = w.getObjects(Item.class);

        //creates a list of weapons to remove when the level variable changes
        List<Weapons> weapons = w.getObjects(Weapons.class);

        //this switches the map every time the hero reaches the edge 
        //of the world, and removes everything that doesn't belong in the new map
        if(level == 1)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 2;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 4;
                setNewMap();
            }
        }
        else if(level == 2)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 3;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 1;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                if(keyItems == false)
                {
                    w.removeObjects(tiles);
                    w.removeObjects(enemies);
                    w.removeObjects(weapons);
                    w.removeObjects(items);
                    flipSides();
                    level = 33;
                    setNewMap();
                }
                else if(keyItems == true)
                {
                    w.removeObjects(tiles);
                    w.removeObjects(enemies);
                    w.removeObjects(weapons);
                    w.removeObjects(items);
                    flipSides();
                    level = 34;
                    music.stop();
                    music = new GreenfootSound("Boss Music.mid");
                    music.playLoop();
                    setNewMap();
                }
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 5;
                setNewMap();
            }
        }
        else if(level == 3)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 2;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 6;
                setNewMap();
            }
        }
        else if(level == 4)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 5;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 1;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 7;
                setNewMap();
            }
        }
        else if(level == 5)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 6;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 4;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 8;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 2;
                setNewMap();
            }
        }
        else if(level == 6)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 5;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 3;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 9;
                setNewMap();
            }
        }
        else if(level == 7)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 8;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 4;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 19;
                music.stop();
                music = new GreenfootSound("Wandering In Gorgotha.mid");
                music.playLoop();
                setNewMap();
            }
        }
        else if(level == 8)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 7;
                setNewMap();
            }
            else if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 9;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 5;
                setNewMap();
            }
        }
        else if(level == 9)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 20;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 8;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 6;
                setNewMap();
            }
        }
        else if(level == 10)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 11;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                if (heroMystery == false && wMystery == false)
                {
                    w.addObject(new Mystery(), 500, 300);
                    wMystery = true;
                }
                flipSides();
                level = 32;
                setNewMap();
            }
        }
        else if(level == 11)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 12;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 10;
                setNewMap();
            }
        }
        else if(level == 12)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 11;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 15;
                setNewMap();
            }
        }
        else if(level == 13)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 14;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 16;
                setNewMap();
            }
        }
        else if(level == 14)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 15;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 13;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 17;
                setNewMap();
            }            
        }
        else if(level == 15)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 14;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 12;
                setNewMap();
            }
        }
        else if(level == 16)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 17;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 13;
                setNewMap();
            }
        }
        else if(level == 17)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 18;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 16;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 14;
                setNewMap();
            }
        }
        else if(level == 18)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 17;
                setNewMap();
            }
            else if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 19;
                setNewMap();
            }
        }
        else if(level == 19)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 18;
                setNewMap();
            }
            else if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 7;
                music.stop();
                music = new GreenfootSound("CoolDude Music.mid");
                music.playLoop();
                setNewMap();
            }
        }
        else if(level == 20)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 9;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 21;
                music.stop();
                music = new GreenfootSound("Witzwood Swamp.mid");
                music.playLoop();
                setNewMap();
            }
        }
        else if(level == 21)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 22;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 20;
                music.stop();
                music = new GreenfootSound("CoolDude Music.mid");
                music.playLoop();
                setNewMap();
            }
        }
        else if(level == 22)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 23;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 21;
                setNewMap();
            }
        }
        else if(level == 23)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 24;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 22;
                setNewMap();
            }
        }
        else if(level == 24)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 23;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 26;
                setNewMap();
            }
        }
        else if(level == 25)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 26;
                setNewMap();
            }
        }
        else if(level == 26)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 27;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 25;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 24;
                setNewMap();
            }
        }
        else if(level == 27)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 28;
                setNewMap();
            }
            else if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 26;
                setNewMap();
            }
        }
        else if(level == 28)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 27;
                setNewMap();
            }
            else if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 30;
                setNewMap();
            }
        }
        else if(level == 29)
        {
            if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                if (heroShades == false && wShades == true)
                {
                    Shades s = (Shades) getWorld().getObjects(Shades.class).get(0);
                    w.removeObject(s);
                    wShades = false;
                }
                flipSides();
                level = 31;
                setNewMap();
            }
        }
        else if(level == 30)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 31;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 28;
                setNewMap();
            }
        }
        else if(level == 31)
        {
            if(getX() <= 114)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 30;
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                if (heroShades == false && wShades == false)
                {
                    w.addObject(new Shades(), 500, 300);
                    wShades = true;
                }
                flipSides();
                level = 29;
                setNewMap();
            }
        }
        else if(level == 32)
        {
            if(getX() >= getWorld().getWidth() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                if (heroMystery == false && wMystery == true)
                {
                    Mystery m = (Mystery) getWorld().getObjects(Mystery.class).get(0);
                    w.removeObject(m);
                    wMystery = false;
                }
                flipSides();
                level = 10;
                setNewMap();
            }
        }
        else if(level == 33)
        {
            if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 2;
                setNewMap();
            }
        }
        else if(level == 34)
        {
            if(getY() >= getWorld().getHeight() - 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 2;
                music.stop();
                music = new GreenfootSound("CoolDude Music.mid");
                music.playLoop();
                setNewMap();
            }
            else if(getY() <= 6)
            {
                w.removeObjects(tiles);
                w.removeObjects(enemies);
                w.removeObjects(weapons);
                w.removeObjects(items);
                flipSides();
                level = 35;
                setNewMap();
            }
        }
        else if(level == 35)
        {
            if(wBoss == false)
            {
                w.addObject(new LikeABoss(), getWorld().getWidth() / 2, 100);
                wBoss = true;
            }

        }
    }

    //this method will set the new map based on the level variable
    public void setNewMap()
    {
        if(level == 1)
        {
            readMapFile("map1.txt");
        }
        else if(level == 2)
        {
            readMapFile("map2.txt");
        }
        else if(level == 3)
        {
            readMapFile("map3.txt");
        }
        else if(level == 4)
        {
            readMapFile("map4.txt");
        }
        else if(level == 5)
        {
            readMapFile("map5.txt");
        }
        else if(level == 6)
        {
            readMapFile("map6.txt");
        }
        else if(level == 7)
        {
            readMapFile("map7.txt");
        }
        else if(level == 8)
        {
            readMapFile("map8.txt");
        }
        else if(level == 9)
        {
            readMapFile("map9.txt");
        }
        else if(level == 10)
        {
            readMapFile("map10.txt");
        }
        else if(level == 11)
        {
            readMapFile("map11.txt");
        }
        else if(level == 12)
        {
            readMapFile("map12.txt");
        }
        else if(level == 13)
        {
            readMapFile("map13.txt");
        }
        else if(level == 14)
        {
            readMapFile("map14.txt");
        }
        else if(level == 15)
        {
            readMapFile("map15.txt");
        }
        else if(level == 16)
        {
            readMapFile("map16.txt");
        }
        else if(level == 17)
        {
            readMapFile("map17.txt");
        }
        else if(level == 18)
        {
            readMapFile("map18.txt");
        }
        else if(level == 19)
        {
            readMapFile("map19.txt");
        }
        else if(level == 20)
        {
            readMapFile("map20.txt");
        }
        else if(level == 21)
        {
            readMapFile("map21.txt");
        }
        else if(level == 22)
        {
            readMapFile("map22.txt");
        }
        else if(level == 23)
        {
            readMapFile("map23.txt");
        }
        else if(level == 24)
        {
            readMapFile("map24.txt");
        }
        else if(level == 25)
        {
            readMapFile("map25.txt");
        }
        else if(level == 26)
        {
            readMapFile("map26.txt");
        }
        else if(level == 27)
        {
            readMapFile("map27.txt");
        }
        else if(level == 28)
        {
            readMapFile("map28.txt");
        }
        else if(level == 29)
        {
            readMapFile("map29.txt");
        }
        else if(level == 30)
        {
            readMapFile("map30.txt");
        }
        else if(level == 31)
        {
            readMapFile("map31.txt");
        }
        else if(level == 32)
        {
            readMapFile("map32.txt");
        }
        else if(level == 33)
        {
            readMapFile("map33.txt");
        }
        else if(level == 34)
        {
            readMapFile("map34.txt");
        }
        else if(level == 35)
        {
            readMapFile("map35.txt");
        }
    }

    //this controls movement, and action.
    public void checkKeyPress()
    {
        //walking left
        if ( Greenfoot.isKeyDown("A"))
        {
            directionFacing = LEFT;  
            setLocation(this.getX() - speed, this.getY());
            timer++;
            if (timer > 10 && timer < 20)
            {
                setImage(imageLeft2);
            }
            else if (timer > 19 && timer < 30)
            {
                setImage(imageLeft3);
            }
            else if (timer > 29 && timer < 40)
            {
                setImage(imageLeft4);
            }
            else if (timer > 39)
            {
                setImage(imageLeft1);
                timer = 0;
            }
            if(getOneIntersectingObject(Tile.class) != null)
            {
                setLocation(getX() + speed, getY());
            }
        }
        //walking up
        else if ( Greenfoot.isKeyDown("W"))
        {
            directionFacing = UP;
            setLocation(this.getX(), this.getY() - speed);
            timer++;
            if (timer > 10 && timer < 20)
            {
                setImage(imageUp2);
            }
            else if (timer > 19 && timer < 30)
            {
                setImage(imageUp3);
            }
            else if (timer > 29 && timer < 40)
            {
                setImage(imageUp4);
            }
            else if (timer > 39)
            {
                setImage(imageUp1);
                timer = 0;
            }
            if(getOneIntersectingObject(Tile.class) != null)
            {
                setLocation(getX(), getY() + (speed));
            }
        }
        //walking down
        else if ( Greenfoot.isKeyDown("D"))
        {
            directionFacing = RIGHT;
            setLocation(this.getX() + speed, this.getY());
            timer++;
            if (timer > 10 && timer < 20)
            {
                setImage(imageRight2);
            }
            else if (timer > 19 && timer < 30)
            {
                setImage(imageRight3);
            }
            else if (timer > 29 && timer < 40)
            {
                setImage(imageRight4);
            }
            else if (timer > 39)
            {
                setImage(imageRight1);
                timer = 0;
            }
            if(getOneIntersectingObject(Tile.class) != null)
            {
                setLocation(getX() - speed, getY());
            }
        }
        //walking right
        else if ( Greenfoot.isKeyDown("S"))
        {
            directionFacing = DOWN;
            setLocation(this.getX(), this.getY() + speed);
            timer++;
            if (timer > 10 && timer < 20)
            {
                setImage(imageDown2);
            }
            else if (timer > 19 && timer < 30)
            {
                setImage(imageDown3);
            }
            else if (timer > 29 && timer < 40)
            {
                setImage(imageDown4);
            }
            else if (timer > 39)
            {
                setImage(imageDown1);
                timer = 0;
            }
            if(getOneIntersectingObject(Tile.class) != null)
            {
                setLocation(getX(), getY() - speed);
            }
        }
        if (Greenfoot.isKeyDown("N"))
        {
            fire();
        }

        if(Greenfoot.isKeyDown("C") && music.isPlaying())           
        {
            music.pause();
        }
        else if(Greenfoot.isKeyDown("V") && !music.isPlaying())
        {
            music.playLoop();
        }
    }

    //the method that determines how to throw your weapon
    private void fire()
    {
        if (fireTimer == 0)
        {
            Sword sword = new Sword();
            getWorld().addObject(sword, getX(), getY());
            sword.turn(directionFacing);
            sword.move(30);
            fireTimer = REFIRERATE;
        }
    }

    public void lookForItem()
    {
        CoolDudeWorld w = (CoolDudeWorld) getWorld();
        if (canSee(Apple.class))
        {
            if(life < maxLife)
            {
                life = life + 5;                
                if (life > maxLife)
                {
                    life = maxLife;   
                }
            }
            w.updateLifeDisplay(getLife());
            eat(Apple.class);
            Greenfoot.playSound("apple.wav");
        }
        else if (canSee(GreenApple.class))
        {
            if(maxLife < TOTALMAXLIFE)
            {
                maxLife = maxLife + 10;
            }
            w.updateMaxLifeDisplay(maxLife);
            eat(GreenApple.class);
            Greenfoot.playSound("apple.wav");
        }
        else if (canSee(BluePowerBall.class))
        {
            swordLife = swordLife + 5;
            if(swordLife > SWORDLIFEMAX)
            {
                swordLife = SWORDLIFEMAX;
            }
            w.updateDistanceDisplay(swordLife);
            eat(BluePowerBall.class);
        }
        else if (canSee(RedPowerBall.class))
        {
            swordDamage = swordDamage + 5;
            if (swordDamage > MAXSWORDDAMAGE)
            {
                swordDamage = MAXSWORDDAMAGE;
            }
            w.updateDamageDisplay(swordDamage);
            eat(RedPowerBall.class);
        }
        else if (canSee(Bananas.class))
        {
            if(life < maxLife)
            {
                life = life + 20;             
                if (life >= maxLife)
                {
                    life = maxLife;                             
                }
            }
            w.updateLifeDisplay(getLife());
            eat(Bananas.class);
            Greenfoot.playSound("apple.wav");
        }
        else if (canSee(GreenPowerBall.class))
        {
            if(speed > MAXSPEED)
            {
                speed = MAXSPEED;
            }
            else if(speed < MAXSPEED)
            {
                speed = speed + 1;
            }
            w.updateSpeedDisplay(speed);
            eat(GreenPowerBall.class);
        }
        else if (canSee(Shades.class))
        {
            eat(Shades.class);
            heroShades = true;
            w.addObject(new Shades(), 50, 200);
            if(heroMystery && heroShades == true)
            {
                keyItems = true;
            }
        }
        else if (canSee(Mystery.class))
        {
            eat(Mystery.class);
            heroMystery = true;
            w.addObject(new Mystery(), 48, 270);
            if(heroMystery && heroShades == true)
            {
                keyItems = true;
            }
        }
        else if (canSee(FangNecklace.class))
        {
            eat(FangNecklace.class);
            music.stop();
            youWin();
        }
    }

    //this will make the hero die if his life is less tahn 1
    public void die()
    {
        if (life < 1)
        {
            getWorld().addObject(new GameOver(), getWorld().getWidth() / 2 + 50, getWorld().getHeight() / 2);
            music.stop();
            Greenfoot.stop();
            getWorld().removeObject(this);    
        }
    }

    //this will activate if the hero is hit.
    public void hit(int damage)
    {

        Greenfoot.playSound("herohurt.wav");
        life = life - damage;
        CoolDudeWorld w = (CoolDudeWorld) getWorld();
        w.updateLifeDisplay(getLife());
        if(life <= 0)
            die();
    }

    //this gets the variable life for use in the class CoolDudeWorld
    public static int getLife()
    {
        return life;
    }

    //reduces the fire timer so that you can shoot again.
    public void reduceFireTimer()
    {
        if (fireTimer > 0)
        {
            fireTimer--;
        }
    }

    public void readMapFile(String map)
    {
        InputStream istream = getClass().getResourceAsStream(map);
        String[] textmap = new String[MAP_HEIGHT];
        Scanner s = new Scanner(new BufferedReader(new InputStreamReader(istream)));
        int i = 0;
        while(s.hasNextLine())
        {
            String line = s.nextLine();
            textmap[i] = line;
            i++;
        }
        s.close();

        addTiles(textmap);
    }

    private void addTiles(String[] THEMAP)
    {
        for(int y = 0; y < THEMAP.length; y++)
        {
            addColumn(y, THEMAP);
        }
    }

    private void addColumn(int y, String[] THEMAP)
    {
        int tileY = topY + TILE_HEIGHT * y;
        String row = THEMAP[y];

        for (int x = 0; x < row.length(); x++)
        {
            int tileX = leftX + TILE_WIDTH * x;

            char type = row.charAt(x);
            if(type == 'B')
            {
                getWorld().addObject(new Tile(1), tileX, tileY);
            }
            else if(type == 'T')
            {
                getWorld().addObject(new Tile(2), tileX, tileY);
            }
            else if(type == 't')
            {
                getWorld().addObject(new Tile(3), tileX, tileY);
            }
            else if(type == 'F')
            {
                getWorld().addObject(new Tile(4), tileX, tileY);
            }
            else if(type == 'J')
            {
                getWorld().addObject(new Tile(5), tileX, tileY);
            }
            else if(type == 'Y')
            {
                getWorld().addObject(new Tile(6), tileX, tileY);
            }
            else if(type == 'U')
            {
                getWorld().addObject(new Tile(7), tileX, tileY);
            }
            else if(type == 'I')
            {
                getWorld().addObject(new Tile(8), tileX, tileY);
            }  
            else if(type == 'K')
            {
                getWorld().addObject(new Tile(9), tileX, tileY);
            }              
            else if(type == ',')
            {
                getWorld().addObject(new Tile(10), tileX, tileY);
            }              
            else if(type == 'M')
            {
                getWorld().addObject(new Tile(11), tileX, tileY);
            }              
            else if(type == 'N')
            {
                getWorld().addObject(new Tile(12), tileX, tileY);
            }    
            else if(type == 'H')
            {
                getWorld().addObject(new Tile(13), tileX, tileY);
            }
            else if(type == 'A')
            {
                getWorld().addObject(new Tile(14), tileX, tileY);
            }
            else if(type == 'C')
            {
                getWorld().addObject(new Tile(15), tileX, tileY);
            }
            else if(type == 'D')
            {
                getWorld().addObject(new Tile(16), tileX, tileY);
            }
            else if(type == 'S')
            {
                getWorld().addObject(new Skeleton(), tileX, tileY);
            }
            else if(type == 'E')
            {
                getWorld().addObject(new EvilKnight(), tileX, tileY);
            }
            else if(type == 'R')
            {
                getWorld().addObject(new Robot(), tileX, tileY);
            }
            else if(type == 'G')
            {
                getWorld().addObject(new Ghost(), tileX, tileY);
            }
            else if(type == '1')
            {
                getWorld().addObject(new Tile(17), tileX, tileY);
            }
            else if(type == '2')
            {
                getWorld().addObject(new Tile(18), tileX, tileY);
            }
            else if(type == '3')
            {
                getWorld().addObject(new Tile(19), tileX, tileY);
            }
            else if(type == '4')
            {
                getWorld().addObject(new Tile(20), tileX, tileY);
            }
            else if(type == '5')
            {
                getWorld().addObject(new Tile(21), tileX, tileY);
            }
            else if(type == '6')
            {
                getWorld().addObject(new Tile(22), tileX, tileY);
            }
            else if(type == '7')
            {
                getWorld().addObject(new Tile(23), tileX, tileY);
            }
            else if(type == '8')
            {
                getWorld().addObject(new Tile(24), tileX, tileY);
            }
            else if(type == '9')
            {
                getWorld().addObject(new Tile(25), tileX, tileY);
            }
            else if(type == 'Q')
            {
                getWorld().addObject(new Tile(26), tileX, tileY);
            }
            else if(type == 'Z')
            {
                getWorld().addObject(new Tile(27), tileX, tileY);
            }
            else if(type == 'X')
            {
                getWorld().addObject(new Tile(28), tileX, tileY);
            }
        }
    }
    
    public void youWin()
    {
        Greenfoot.setWorld(new EndWorld());
    }

}
