import greenfoot.*;

public class Laser extends Weapons
{
    private int timer;
    
    private GreenfootImage laser1, laser2, laser3;
    
    private int laserSpeed = 20;
    
    private static final int damage = 5;
    
    public Laser()
    {
        laser1 = new GreenfootImage("laser1.png");
        laser2 = new GreenfootImage("laser2.png");
        laser3 = new GreenfootImage("laser3.png");
        
        setImage(laser1);
    }
    
    public void act()
    {
        checkHit();
        move(laserSpeed);
        animateLaser();
    }
    
    private void checkHit()
    {
        Hero hero = (Hero) getOneIntersectingObject(Hero.class);
        if (hero != null)
        {
            getWorld().removeObject(this);
            hero.hit(damage);
        }
        else if(atWorldEdge())
        {
            getWorld().removeObject(this);
        }
    }
    
    public void animateLaser()
    {
        timer++;
        if (timer > 5 && timer < 10)
        {
            setImage(laser1);
        }
        if (timer > 9 && timer < 15)
        {
            setImage(laser2);
        }
        if (timer > 14 )
        {
            setImage(laser3);
            timer = 0;
        }
    }
}