import greenfoot.*;

public class LikeABoss extends Enemy
{

    private int life;
    
    private int leafTimer = 40;
    
    private GreenfootImage imageRight, imageLeft;
    
    private final int SPEED = 3;
    
    private int directionFacing;
    private int stepCount;
    private final int MOVEDISTANCE = 30;
    
    private int leafDirection = 90;
    
    public LikeABoss()
    {
        imageRight = new GreenfootImage("WomBoss.png");
        imageLeft = new GreenfootImage("WomBoss2.png");
        
        life = 700;
        
        setImage(imageRight);
    }
    
    public void bossMove()
    {
        if(stepCount < MOVEDISTANCE)
        {
            if(directionFacing == 0)
            {
                setLocation(getX() + SPEED, getY());
                stepCount++;
            }
            else if(directionFacing == 1)
            {
                setLocation(getX() - SPEED, getY());
                stepCount++;
            }
        }
        if(stepCount > MOVEDISTANCE-1)
        {
            stepCount = 0;
            setDirection();
        }
    }
    
    private int chooseDirection()
    {
        int direction = Greenfoot.getRandomNumber(2);
        return (direction);
    }
    
    private void setDirection()
    {
        if(Greenfoot.getRandomNumber(100) < 25)
        {
            chooseDirection();
            if(chooseDirection() == 0)
            {
                setImage(imageRight);
                directionFacing = 0;
            }
            else if(chooseDirection() == 1)
            {
                setImage(imageLeft);
                directionFacing = 1;
            }
        }
    }
    
    private void edgeCorrection()
    {
        if(getX() < 275)
        {
            directionFacing = 0;
            setImage(imageRight);
        }
        else if(getX() > getWorld().getWidth() - 175)
        {
            directionFacing = 1;
            setImage(imageLeft);
        }
    }
    
    public void hit(int damage)
    {
        Greenfoot.playSound("enemyhit.wav");
        life = life - damage;
        if(life <= 0)
            die();
    }
    
    public void die()
    {
        if (life < 1)
        {
            getWorld().addObject(new DeadLikeABoss(), getX(), getY());
            getWorld().addObject(new FangNecklace(), getX(), getY() + 200);
            getWorld().removeObject(this);
            
        }
    }
    
    private void shootLeaves()
    {
        if(leafTimer == 0 && (Greenfoot.getRandomNumber(100) < 25))
        {
            Leaf leaf = new Leaf();
            getWorld().addObject(leaf, getX(), getY());
            leaf.setRotation(leafDirection);
            leafTimer = 40;
        }
        else if(leafTimer == 0 && (Greenfoot.getRandomNumber(100) > 25 && Greenfoot.getRandomNumber(100) < 50))
        { 
            Hero h = (Hero) getWorld().getObjects(Hero.class).get(0);
            Leaf leaf = new Leaf();
            getWorld().addObject(leaf, getX(), getY());
            leaf.turnTowards(h.getX(), h.getY());
            leafTimer = 40;
        }
    }
    
    public void reduceLeafTimer()
    {
        if(leafTimer > 0)
        {
            leafTimer--;
        }
    }
        
    
    public void act() 
    {
        bossMove();
        edgeCorrection();
        shootLeaves();
        reduceLeafTimer();
    }    
}
