import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class StatusBar here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class StatusBars extends Actor
{

    private static final Color DEFAULT_COLOR = new Color(0, 0, 255, 128);
    private Color barColor = DEFAULT_COLOR;
    private GreenfootImage image;
    private int width;
    private int height;
    private int percentFilled;

    /**
     * Act - do whatever the StatusBar wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    

    private void makeImage()
    {
        image = new GreenfootImage(width, height);
        image.setColor(Color.WHITE);
        image.drawRect(0, 0, width - 1, height - 1);
        int barWidth = (int) (percentFilled / 100.0
                * (width - 2));
        image.setColor(barColor);
        image.fillRect(1, 1, barWidth , height - 2);
        setImage(image);
    }

    public StatusBars()
    {
        this (100, 25);
    }

    public StatusBars(int newWidth, int newHeight)
    {
        width = newWidth;
        height = newHeight;
        makeImage();
    }

    public void setPercentageFilled(int percentageFilled)
    {
        if (percentageFilled < 0)
        {
            percentageFilled = 0;
        }
        else if (percentageFilled > 100)
        {
            percentageFilled = 100;
        }
        if (percentFilled != percentageFilled)
        {
            percentFilled = percentageFilled;
            makeImage();
        }
    }

    public void setBarColor(Color newBarColor)
    {
        if (newBarColor == null)
        {
            newBarColor = DEFAULT_COLOR;
        }
        if (!barColor.equals(newBarColor))
        {
            barColor = newBarColor;
            makeImage();
        }

    }

    public int getWidth() {
        return width;
    }

    public int getHeight() {
        return height;
    }

}
